
function [U_ms,center]= fun_trimf(data,type,num,defin) 

delta=(max(data)-min(data))/(num-1); 
if type==0 

    [row, line]=size(data);
    U_ms=zeros(num,line);
    center=zeros(row,num);
    U_ms(1,:)=trimf(data,[min(data) min(data) min(data)+delta]);%[0 0 delta]
    center(:,1)=min(data);
    for i=2:num-1
        U_ms(i,:)=trimf(data,[min(data)+(i-2)*delta min(data)+(i-1)*delta min(data)+i*delta]);
        center(:,i)=min(data)+(i-1)*delta;
    end
    U_ms(num,:)=trimf(data,[(min(data)+(num-2)*delta) max(data) max(data)]);
    center(:,num)=max(data);
end
if type==1
    num=length(defin); %
    [~, line]=size(data);
    U_ms=zeros(num,line);
    center=sort(defin);
    U_ms(1,:)=trimf(data,[min(data) center(1) min(data)+delta]);%[0 center(1) delta]
    %center(:,1)=min(data);
    for i=2:num-1
        U_ms(i,:)=trimf(data,[min(data)+(i-2)*delta center(i) min(data)+i*delta]);
        %center(:,i)=min(data)+(i-1)*delta;
    end
    U_ms(num,:)=trimf(data,[(min(data)+(num-2)*delta) center(num) max(data)]);
    %center(:,num)=max(data);
end
%-----------------------------------
if type==2
    num=length(defin); 
    %------------------
    [~, line]=size(data);
    U_ms=zeros(num,line);
    center=sort(defin);
    U_ms(1,:)=trimf(data,[min(data) center(1) center(2)]);%[0 0 0.25]
    %center(:,1)=min(data);
    for i=2:num-1
        U_ms(i,:)=trimf(data,[center(i-1) center(i) center(i+1)]);
        %center(:,i)=min(data)+(i-1)*delta;
    end
    if center(num) > max(data) 
        U_ms(num,:)=trimf(data,[center(num-1) center(num) center(num)]);
    else
        U_ms(num,:)=trimf(data,[center(num-1) center(num) max(data)]);
    end
end
