
function [low,up,best] = granularity_inclusion(  y_data, m_weight, dataError, data_piont )
num = length(y_data);
[A, A_index] = sort(y_data);
weight = m_weight(A_index);
obj = zeros(num*(num-1)/2, 1);
ranges = zeros(num*(num-1)/2, 2); %
alpha = 1; %
k=1;

for i = 1 : num-1  %
    for ii = i+1 : num
        cov = sum(weight(i:ii)); %/(ii-i)
        sp = abs(A(ii)-A(i));
        ranges(k,:) =[A(i),A(ii)];
    
        if data_piont == A(i) || data_piont == A(ii)
            flag = 1;
        elseif data_piont > A(i) && data_piont < A(ii)
            flag = 1;
        else
            flag=0;
        end
        %
        obj(k) = cov * exp(- alpha*sp)*flag;
        k=k+1;
    end
end
[max_value,position]=max(obj);
low = ranges(position,1);
up = ranges(position,2);


[~, w_index] = sort(m_weight);
B = y_data(w_index);

k1 = 1;   
interval_data = zeros(num,1);%  
interval_error  = zeros(num,1);%  
for i=1:num
    if y_data(i) >= low && y_data(i) <= up
        interval_data(k1) = y_data(i);
        interval_error(k1) = dataError(i);
        k1 = k1+1;
    end
end
interval_data = interval_data(1:k1-1);
interval_error = interval_error(1:k1-1);
interval_weight = (1./interval_error)./sum(1./interval_error);
best = sum(interval_weight.*interval_data);%  

end


